package dataInterpretation;

public class Calculations {

	// calculate max of a data set within a specified time period
	double calcMax(double data[], int timeLength, boolean hour) {
		double max = -1.0;

		if (hour == true) {
			// timemÂlinger

			for (int i = data.length - 1; i >= data.length - timeLength; i--) {
				if (data[i] > max) {
					max = data[i];
				}
			}
		} else {
			// minuttmÂlinger

			for (int i = data.length - 1; i >= data.length - (timeLength * 60); i--) {
				if (data[i] > max) {
					max = data[i];

				}
			}
		}
		return max;
	}

	// calculate min of a data set within a specified time period
	double calcMin(double data[], int timeLength, boolean hour) {
		double min = 1000000;

		if (hour == true) {
			// timemÂlinger

			for (int i = data.length - 1; i >= data.length - timeLength; i--) {

				if (data[i] < min) {
					min = data[i];
				}
			}
		} else {
			// minuttmÂlinger

			for (int i = data.length - 1; i >= data.length - (timeLength * 60); i--) {
				if (data[i] < min) {
					min = data[i];
				}
			}
		}
		return min;
	}

	// calculate avg of a data set within a specified time period
	double calcAvg(double data[], int timeLength, boolean hour) {
		double avg = 0;

		if (hour == true) {
			// timemÂlinger

			for (int i = data.length - 1; i >= data.length - timeLength; i--) {
				avg += data[i];
			}
			avg /= timeLength;
		} else {
			// minuttmÂlinger

			for (int i = data.length - 1; i >= data.length - (timeLength * 60); i--) {
				avg += data[i];
			}
			avg /= timeLength;
		}
		return avg;
	}

	// calculate slope of a data set within a specified time period
	double calcSlope(double yData[], int timeLength, boolean hour) {
		double avgX = 0;
		double avgY = calcAvg(yData, timeLength, hour);
		double r = 0;
		double sX = 0;
		double sY = 0;
		double slope = 0;
		double rX = 0;
		double rY = 0;
		int counter = 1;

		if (hour == true) {
			for (int i = 1; i <= timeLength; i++) {
				avgX += i;
			}
			avgX /= timeLength;

			for (int i = yData.length - 1; i >= yData.length - timeLength; i--) {
				sX += Math.pow((counter - avgX), 2);
				sY += Math.pow((yData[i] - avgY), 2);

				rX = counter - avgX;
				rY = yData[yData.length - counter] - avgY;
				r += rX * rY;

				counter++;
			}

			sX = Math.sqrt(sX / (timeLength - 1));
			sY = Math.sqrt(sY / (timeLength - 1));

			r = (1.0 / (timeLength - 1)) * (r / (sX * sY));

			slope = r * (sY / sX);
		} else {
			for (int i = 1; i <= timeLength * 60; i++) {
				avgX += i;
			}
			avgX /= timeLength * 60;

			for (int i = yData.length - 1; i >= yData.length - timeLength * 60; i--) {
				sX += Math.pow((counter - avgX), 2);
				sY += Math.pow((yData[i] - avgY), 2);

				rX = counter - avgX;
				rY = yData[yData.length - counter] - avgY;
				r += rX * rY;

				counter++;
			}

			sX = Math.sqrt(sX / ((timeLength - 1) * 60));
			sY = Math.sqrt(sY / ((timeLength - 1) * 60));

			r = (1.0 / ((timeLength - 1) * 60)) * (r / (sX * sY));

			slope = r * (sY / sX);
		}

		return slope;

	}
}
