package GUI;

import javafx.application.Application;
import javafx.fxml.FXMLLoader;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.stage.Stage;

public class Loader extends Application {

	@Override
	public void start(Stage primaryStage) {
		try {
			
			//System.getProperty("user.dir") + "/gui/PontusGUI.fxml"
			Parent root = FXMLLoader.load(getClass().getClassLoader().getResource("PontusGUI.fxml"));
					
			Scene scene = new Scene(root);
			// scene.getStylesheets().add(getClass().getResource("application.css").toExternalForm());
			primaryStage.setScene(scene);
			primaryStage.show();
			primaryStage.setTitle("Pontus");
			
			//run the thread initially
			Controller.R1.start();

		} catch (Exception e) {
			e.printStackTrace();
		}

	}

}
